import { IUser, IImpersonateReturn, ITokens, ICreateUser, ILoginUserIdentity, IPassword, ILoginReturn } from '@identity-stack/core';
import { IdentityState } from './identity';
export interface IAccountsClient {
    getState(): IdentityState;
    getStorageData(keyName: string): Promise<string>;
    setStorageData(keyName: string, value: any): Promise<string>;
    removeStorageData(keyName: string): Promise<string>;
    loadTokensFromStorage(): Promise<void>;
    loadOriginalTokensFromStorage(): Promise<void>;
    user(): IUser;
    impersonate(username: string): Promise<IImpersonateReturn>;
    stopImpersonation(): Promise<void>;
    isImpersonated(): boolean;
    originalTokens(): ITokens;
    clearTokens(): Promise<void>;
    storeTokens(tokens: ITokens): Promise<void>;
    storeOriginalTokens(token: ITokens): Promise<void>;
    clearUser(): any;
    resumeSession(): Promise<void>;
    refreshSession(): Promise<void>;
    createUser(user: ICreateUser, callback?: (err?: Error) => void): Promise<void>;
    loginWithPassword(user: ILoginUserIdentity, password: IPassword, callback?: (err?: Error, res?: ILoginReturn) => void): Promise<ILoginReturn>;
    loggingIn(): boolean;
    isLoading(): boolean;
    logout(callback: (err?: Error) => void): Promise<void>;
    verifyEmail(token: string): Promise<void>;
    resetPassword(token: string, newPassword: string): Promise<void>;
    requestPasswordReset(email: string): Promise<void>;
    requestVerificationEmail(email: string): Promise<void>;
}
